/* C code produced by gperf version 2.1 (K&R C version) */
/* Command-line: ../src/gperf -k1,2,$ -o modula3.gperf  */



#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 9
#define MIN_HASH_VALUE 4
#define MAX_HASH_VALUE 246
/*
  106 keywords
  243 is the maximum key range
*/

static int
hash (str, len)
     register char *str;
     register unsigned int  len;
{
  static unsigned char hash_table[] =
    {
     246, 246, 246, 246, 246, 246, 246, 246, 246, 246,
     246, 246, 246, 246, 246, 246, 246, 246, 246, 246,
     246, 246, 246, 246, 246, 246, 246, 246, 246, 246,
     246, 246, 246, 246, 246, 246, 246, 246, 246, 246,
     246, 246, 246, 246, 246, 246, 246, 246, 246, 246,
     246, 246, 246, 246, 246, 246, 246, 246, 246, 246,
     246, 246, 246, 246, 246,  10, 100,   0,  50,   0,
      10, 246,  40,  25, 246,   0,  40,  20,   5,  95,
      40, 246,   0,   0,  45,  50, 110,  45,  55,  35,
     246, 246, 246, 246, 246, 246, 246,   5,  10,   0,
      25,   0,   5, 246,   0,  20, 246,   0,   0,  70,
       0,  87,  50, 246,   0,  75,  15,  65,  72,   0,
      45,  55, 246, 246, 246, 246, 246, 246,
  };
  return len + hash_table[str[1]] + hash_table[str[0]] + hash_table[str[len - 1]];
}

char *
in_word_set (str, len)
     register char *str;
     register unsigned int len;
{

  static char * wordlist[] =
    {
      "", "", "", "", 
      "else", 
      "while", 
      "return", 
      "", 
      "ref", 
      "case", 
      "elsif", 
      "RETURN", 
      "", 
      "REF", 
      "CASE", 
      "begin", 
      "RAISES", 
      "", "", 
      "then", 
      "", 
      "repeat", 
      "in", 
      "", 
      "with", 
      "", 
      "inline", 
      "METHODS", 
      "end", 
      "interface", 
      "", 
      "record", 
      "if", 
      "and", 
      "FROM", 
      "", 
      "INLINE", 
      "IN", 
      "", 
      "INTERFACE", 
      "", "", "", 
      "READONLY", 
      "ELSE", 
      "", "", 
      "IF", 
      "SET", 
      "PROCEDURE", 
      "ARRAY", 
      "REPEAT", 
      "", "", 
      "exception", 
      "ELSIF", 
      "RECORD", 
      "", 
      "END", 
      "procedure", 
      "", 
      "UNSAFE", 
      "EXPORTS", 
      "readonly", 
      "exit", 
      "array", 
      "except", 
      "", 
      "AND", 
      "EXCEPTION", 
      "until", 
      "unsafe", 
      "", 
      "try", 
      "type", 
      "", 
      "eval", 
      "FINALLY", 
      "typecase", 
      "from", 
      "var", 
      "", 
      "value", 
      "TRY", 
      "TYPE", 
      "", 
      "raises", 
      "finally", 
      "TYPECASE", 
      "or", 
      "WHILE", 
      "lock", 
      "", 
      "set", 
      "THEN", 
      "for", 
      "IMPORT", 
      "OR", 
      "untraced", 
      "of", 
      "UNTIL", 
      "", "", "", 
      "EXIT", 
      "not", 
      "EXCEPT", 
      "const", 
      "FOR", 
      "bits", 
      "BEGIN", 
      "import", 
      "", 
      "UNTRACED", 
      "WITH", 
      "", "", 
      "OF", 
      "object", 
      "", 
      "div", 
      "MODULE", 
      "by", 
      "VAR", 
      "", 
      "VALUE", 
      "", 
      "exports", 
      "", 
      "BITS", 
      "", "", "", "", "", "", "", "", "", 
      "LOCK", 
      "", "", "", "", "", 
      "CONST", 
      "", "", 
      "NOT", 
      "", "", "", 
      "methods", 
      "", 
      "EVAL", 
      "", "", "", "", "", "", "", "", 
      "module", 
      "", "", "", "", 
      "MOD", 
      "", "", "", 
      "BY", 
      "", "", "", "", "", "", "", "", "", 
      "", "", "", 
      "mod", 
      "", "", 
      "DIV", 
      "", "", 
      "to", 
      "", "", "", "", "", "", "", "", "", 
      "do", 
      "", "", "", "", "", "", "", "", "", 
      "", "", "", "", "", "", "", "", "", 
      "", "", "", "", "", "", "", "", "", 
      "", "", "", "", "", "", "", "", 
      "TO", 
      "", "", "", "", 
      "DO", 
      "", "", "", 
      "OBJECT", 
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= MIN_HASH_VALUE)
        {
          register char *s = wordlist[key];

          if (*s == *str && !strcmp (str + 1, s + 1))
            return s;
        }
    }
  return 0;
}
