/* C code produced by gperf version 2.1 (K&R C version) */
/* Command-line: ../src/gperf -p -c -l -S1 -C -o c.gperf  */



#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 8
#define MIN_HASH_VALUE 3
#define MAX_HASH_VALUE 48
/*
   32 keywords
   46 is the maximum key range
*/

static int
hash (str, len)
     register char *str;
     register unsigned int  len;
{
  static const unsigned char hash_table[] =
    {
     48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
     48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
     48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
     48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
     48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
     48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
     48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
     48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
     48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
     48, 48, 48, 48, 48, 48, 48, 28,  5, 15,
      5,  0, 20, 13, 10,  0, 48,  0, 20,  5,
     23,  0, 48, 48,  5, 10,  0, 20,  5,  0,
     48, 48, 48, 48, 48, 48, 48, 48,
    };
  return len + hash_table[str[len - 1]] + hash_table[str[0]];
}

const char *
in_word_set (str, len)
     register char *str;
     register unsigned int len;
{
  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= MIN_HASH_VALUE)
        {
          if (key <= 48)
            {
              const char *resword; int key_len;

              switch (key - 3)
                {
                case   0:
                  resword = "int"; key_len = 3; break;
                case   1:
                  resword = "else"; key_len = 4; break;
                case   2:
                  resword = "while"; key_len = 5; break;
                case   4:
                  resword = "do"; key_len = 2; break;
                case   6:
                  resword = "enum"; key_len = 4; break;
                case   7:
                  resword = "break"; key_len = 5; break;
                case   8:
                  resword = "double"; key_len = 6; break;
                case   9:
                  resword = "default"; key_len = 7; break;
                case  10:
                  resword = "volatile"; key_len = 8; break;
                case  11:
                  resword = "void"; key_len = 4; break;
                case  12:
                  resword = "short"; key_len = 5; break;
                case  13:
                  resword = "struct"; key_len = 6; break;
                case  14:
                  resword = "goto"; key_len = 4; break;
                case  15:
                  resword = "register"; key_len = 8; break;
                case  16:
                  resword = "case"; key_len = 4; break;
                case  17:
                  resword = "const"; key_len = 5; break;
                case  18:
                  resword = "signed"; key_len = 6; break;
                case  19:
                  resword = "if"; key_len = 2; break;
                case  20:
                  resword = "continue"; key_len = 8; break;
                case  21:
                  resword = "char"; key_len = 4; break;
                case  22:
                  resword = "float"; key_len = 5; break;
                case  23:
                  resword = "switch"; key_len = 6; break;
                case  24:
                  resword = "typedef"; key_len = 7; break;
                case  25:
                  resword = "for"; key_len = 3; break;
                case  26:
                  resword = "extern"; key_len = 6; break;
                case  28:
                  resword = "static"; key_len = 6; break;
                case  29:
                  resword = "auto"; key_len = 4; break;
                case  30:
                  resword = "unsigned"; key_len = 8; break;
                case  31:
                  resword = "return"; key_len = 6; break;
                case  33:
                  resword = "sizeof"; key_len = 6; break;
                case  34:
                  resword = "long"; key_len = 4; break;
                case  45:
                  resword = "union"; key_len = 5; break;
                default: return 0;
                }
              if (len == key_len && *str == *resword && !strncmp (str + 1, resword + 1, len - 1))
                return resword;
              return 0;
            }
         }
    }
  return 0;
}
